#ifndef _ASCIIReader_h
#define _ASCIIReader_h



#include "Reader.h"

class Stack;
class Hashtable;



class ASCIIReader : public Reader
{
public:
	
		// primitive "builtin" value types
	virtual char readChar();
	virtual unsigned char readUChar();
	virtual char* readCharPtr();
	virtual unsigned char* readUCharPtr();
	virtual long readLong();
	virtual unsigned long readULong();
	virtual short readShort();
	virtual unsigned short readUShort();
	virtual int readInt();
	virtual unsigned int readUInt();
	virtual float readFloat();
	virtual double readDouble();
	virtual bool readBool();
	
		// non-primitive value types not under framework control
	virtual String& readString();
	virtual List* readList();
	virtual Stack* readStack();

		// non-primitive value types under framework control
	virtual Value& readValue();

		// references to objects
	virtual Object* readObject();
	virtual Object* readRoot();

	ASCIIReader(istream&);
	
private:

	virtual void skipHeader();

	istream& buffer;
	
	Hashtable* built;

};



#endif

