#include "Account.h"
#include "Reader.h"
#include "Writer.h"



void Account::acceptReader(Reader* reader)
{
	money = (Money&)(reader->readValue());
}

void Account::acceptWriter(Writer* writer) const
{
	writer->writeValue(money);
}

const char* Account::typeName() const
{
	return "Account";
}

Money& Account::balance()
{
	return money;
}

void Account::balance(Money& m)
{
	money = m;
}

void Account::deposit(Amount& a)
{
	money += a;
}

void Account::deposit(Money& m)
{
	money += m;
}

void Account::withdraw(Amount& a)
{
	money -= a;
}

void Account::withdraw(Money& m)
{
	money -= m;
}

Account::Account()
{
}

Account::Account(const Account& ac)
{
	money = ac.money;
}
