#ifndef _Reader_h
#define _Reader_h



#include "Types.h"

class String;
class List;
class Stack;
class Value;
class Object;



class Reader
{
public:
	
		// primitive "builtin" value types
	virtual char readChar() =0;
	virtual unsigned char readUChar() =0;
	virtual char* readCharPtr() =0;
	virtual unsigned char* readUCharPtr() =0;
	virtual long readLong() =0;
	virtual unsigned long readULong() =0;
	virtual short readShort() =0;
	virtual unsigned short readUShort() =0;
	virtual int readInt() =0;
	virtual unsigned int readUInt() =0;
	virtual float readFloat() =0;
	virtual double readDouble() =0;
	virtual bool readBool() =0;
	
		// non-primitive value types not under framework control
	virtual String& readString() =0;
	virtual List* readList() =0;
	virtual Stack* readStack() =0;

		// non-primitive value types under framework control
	virtual Value& readValue() =0;

		// references to objects
	virtual Object* readObject() =0;
	virtual Object* readRoot() =0;

};



#endif

