#ifndef _Writer_h
#define _Writer_h



#include "Types.h"

class String;
class List;
class Stack;
class Value;
class Object;



class Writer
{
public:
	
		// primitive "builtin" value types
	virtual void writeChar(const char) =0;
	virtual void writeUChar(unsigned char) =0;
	virtual void writeCharPtr(const char*) =0;
	virtual void writeUCharPtr(const unsigned char*) =0;
	virtual void writeLong(long) =0;
	virtual void writeULong(unsigned long) =0;
	virtual void writeShort(short) =0;
	virtual void writeUShort(unsigned short) =0;
	virtual void writeInt(int) =0;
	virtual void writeUInt(unsigned int) =0;
	virtual void writeFloat(float) =0;
	virtual void writeDouble(double) =0;
	virtual void writeBool(bool) =0;
	
		// non-primitive value types not under framework control
	virtual void writeString(const String*) =0;
	virtual void writeString(const String&) =0;
	virtual void writeList(const List*) =0;
	virtual void writeList(const List&) =0;
	virtual void writeStack(const Stack*) =0;
	virtual void writeStack(const Stack&) =0;

		// non-primitive value types under framework control
	virtual void writeValue(const Value&) =0;
	virtual void writeValue(const Value*) =0;

		// references to objects
	virtual void writeObject(const Object*) =0;
	virtual void writeObject(const Object&) =0;
	virtual void writeRoot(const Object*) =0;
	virtual void writeRoot(const Object&) =0;

};



#endif

